<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <NuxtLayout name="default">

        <!-- sidebar navigation teleported to template -->
        <SidebarNav :nav="navItems" :navU="navUpdates" :title="'Quick Links'" :titleUpdates="'My Last Updates'" />

        <div class="dashboard-wrapper">
            <div class="row">
                <div class="col-lg-8">
                    <SlidersSliderInfo :sliders="sliders" />
                </div>
                <div class="offset-xl-1 col-xl-3 col-lg-4">
                    <WelcomeUser :user="loggedUser" />
                </div>
            </div>

            <div class="dashboard-cards-wrapper">
                <CardsNumbers :numbers="BigNumbers" />
            </div>

            <!-- <div class="dashboard-title">
                <h2>Created by you</h2>
            </div>

            <div class="dashboard-cards-wrapper">
                <CardsNumbers :numbers="CreatedNumbers" />
            </div> -->

            <TabsDatatableTabs />

            <div class="row">
                <div class="offset-xl-1 col-xl-10">
                    <BannersBannerCta :banners="BannerCta" />
                </div>
            </div>

        </div>

    </NuxtLayout>
</template>

<script setup lang="ts">
import type DataTableI from '~/interfaces/datatable';
import type NavItemI from '~/interfaces/navItem';
import type NavUpdateI from '~/interfaces/navUpdate';
import type sliderItemI from '~/interfaces/sliderItem';
import type userI from '~/interfaces/user';
import slide1 from '@/assets/images/slide1.png';
import slide2 from '@/assets/images/slide2.png';

// const { data: banners } = await useFetchAPI(`/banners?lang=en`);

const dummyClick = () => {
    console.log('dummyClick');
}

const tabs = [
    { id: 'tab1', name: 'Terms' },
    { id: 'tab2', name: 'Glossaries' }
]

const loggedUser = ref<userI>(
    {
        id: 1,
        name: 'Edgar Amorim',
        img: new URL('@/assets/images/user_3.png', import.meta.url).href,
        role: 'Data Scientist',
        info: [
            {
                id: 1,
                title: 'Datasets',
                total: 174,
                action: dummyClick
            },
            {
                id: 2,
                title: 'Data Products',
                total: 24,
                action: dummyClick
            },
            {
                id: 3,
                title: 'Terms',
                total: 231,
                action: dummyClick
            }
        ]
    }
)

const sliders = ref<sliderItemI[]>([
    {
        id: 1,
        title: 'You can now publish your Data Product in AIOD Platform!',
        text: '',
        button_text: 'Know more',
        button_link: 'https://www.google.com',
        media_type: 1,
        media_url: slide1,
        template: 1,
    },
    {
        id: 2,
        title: 'Try out the latest tools!',
        text: '',
        button_text: 'Know more',
        button_link: 'https://www.google.com',
        media_type: 1,
        media_url: slide2,
        template: 2,
    }
])

const BannerCta = ref<sliderItemI[]>([
    {
        id: 1,
        title: 'Have a question or doubts?',
        text: 'Check our FAQs and Documentation',
        button_text: 'Faqs and Documentation',
        button_link: 'https://www.google.com',
        media_type: 1,
        media_url: slide1,
        template: 1,
    }
])

interface NumberBlocks {
    id: number;
    title: string;
    icon: string;
    number: number,
    more_data?: any[],
    link?: string
}

interface Dataset {
    name: string;
    value: number;
}


useFetchAuth(`/search`, { method: 'POST', body: { "type": "CATALOG", "limit": 25, "offset": 0 } }).then((response: any) => {
    const datasets = response;

    const datasetsBlock = BigNumbers.value.find(block => block.title === 'Datasets');

    if (datasetsBlock) {
        // Update the number and more_data with the datasets from the response
        datasetsBlock.number = datasets.length;

        datasetsBlock.more_data = datasets.slice(0, 3).map((dataset: Dataset, index: number) => ({
            id: index + 1,
            name: dataset.name,
            value: 100
        }));

        BigNumbers.value = [...BigNumbers.value];
    }
}).catch(error => {
    console.error('API Error:', error);
});

const BigNumbers = ref<NumberBlocks[]>([
    {
        id: 1,
        title: 'Datasets',
        icon: 'datasets',
        number: 613,
        more_data: []
    },
    {
        id: 2,
        title: 'Domains',
        icon: 'domains',
        number: 731,
        more_data: [],
        link: '/domains'
    },
    {
        id: 3,
        title: 'Quality Rules',
        icon: 'quality_rules',
        number: 1027,
        more_data: []
    },
    {
        id: 4,
        title: 'Data Products',
        icon: 'data_products',
        number: 158,
        more_data: [
            {
                id: 1,
                name: 'COVID-19 Global',
                value: 100
            },
            {
                id: 2,
                name: 'IMDB Movie Reviews',
                value: 100
            },
            {
                id: 3,
                name: 'Forecast Previsions Forecast Previsions',
                value: 100
            }
        ]
    },
    {
        id: 5,
        title: 'Terms',
        icon: 'terms',
        number: 1412,
        more_data: [],
        link: '/terms'
    },
    {
        id: 6,
        title: 'Glossaries',
        icon: 'vocabularies',
        number: 713,
        more_data: [],
        link: '/glossary'
    }
])

// const CreatedNumbers = ref<NumberBlocks[]>([
//     {
//         id: 1,
//         title: 'Data Products',
//         tag: '',
//         number: 8
//     },
//     {
//         id: 2,
//         title: 'Datasets',
//         tag: '',
//         number: 24
//     },
//     {
//         id: 3,
//         title: 'Terms',
//         tag: '',
//         number: 151
//     },
//     {
//         id: 4,
//         title: 'Domains',
//         tag: '',
//         number: 5
//     }
// ]);

const navItems = ref<NavItemI[]>([
    {
        label: 'Home',
        icon: 'home',
        action: dummyClick
    },
    {
        label: 'Data Products',
        preLabel: 'Highlighted',
        icon: 'favourite',
        action: dummyClick
    },
    {
        label: 'Datasets',
        preLabel: 'Highlighted',
        icon: 'favourite',
        action: dummyClick
    },
    {
        label: 'Data Products',
        icon: 'vocabulary',
        action: dummyClick
    },
    {
        label: 'Quick Link 1',
        icon: 'loading',
        action: dummyClick
    }
]);

const navUpdates = ref<NavUpdateI[]>([
    {
        label: 'Datasets',
        preLabel: 'Catalog',
        action: dummyClick
    },
    {
        label: 'Terms',
        preLabel: 'Glossary',
        action: dummyClick
    },
    {
        label: 'Vocabularies',
        preLabel: 'Glossary',
        action: dummyClick
    }
]);

onMounted(() => {

    // // get domains
    // useFetchAuth('/domains').then((response: any) => {
    //     domains.value = [];
    //     for (let i = 0; i < response.length; i++) {
    //         domains.value.push({
    //             id: i,
    //             name: response[i].name,
    //             value: response[i].name
    //         });
    //     }
    // });


    // BigNumbers @6
    // // get vocabularies + terms
    // useFetchAuth('/glossaries').then((response: any) => {
    //     vocabularies.value = [];
    //     for (let i = 0; i < response.length; i++) {

    //         // get terms

    //         vocabularies.value.push({
    //             id: response[i].id,
    //             name: response[i].name,
    //             total: response[i].terms.length,
    //             terms: response[i].terms
    //         });

    //     }
    // });

});


</script>